
module Term.Eval where

open import Prelude
open import Type
open import Term

Value : Type → Set
Value nat      = Nat
Value (a => b) = Value a → Value b

data Dynamic : Set where
  dynamic : (a : Type) → Value a → Dynamic

data Env : Context → Set where
  []  : Env []
  _∷_ : ∀ {Γ x a} → Value a → Env Γ → Env ((x , a) ∷ Γ)

lookupVar : ∀ {a Γ x} → (x , a) ∈ Γ → Env Γ → Value a
lookupVar zero    (v ∷ ρ) = v
lookupVar (suc i) (v ∷ ρ) = lookupVar i ρ

eval : ∀ {Γ a} → Term Γ a → Env Γ → Value a
eval (lit n) ρ = n
-- eval Term.suc ρ = Nat.suc
eval suc ρ = suc
eval (app s t) ρ = eval s ρ (eval t ρ)
eval (lam x t) ρ = λ v → eval t (v ∷ ρ)
eval (var x i) ρ = lookupVar i ρ

-- λ x . suc (suc x)
tm₁ : Term [] (nat => nat)
tm₁ = lam "x" (app suc (app suc (var "x" zero)))

tm₂ : Term [] nat
tm₂ = app tm₁ (lit 5)
